﻿Public Class frmOpen

    Private Sub btnOpen_Click(sender As Object, e As EventArgs) Handles btnOpen.Click
        Dim Response As MsgBoxResult
        'Plain Text open from hereon
        If comboxText.SelectedItem = "Plain Text" And comboxEditor.SelectedItem = "Create new tab & load file" Then
            Dim Open As New OpenFileDialog
            Dim myStreamReader As System.IO.StreamReader
            Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
            Open.CheckFileExists = True
            Open.ShowDialog(Me)
            Try
                Open.OpenFile()
                myStreamReader = System.IO.File.OpenText(Open.FileName)
                Dim richtext As New RichTextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                richtext.BorderStyle = BorderStyle.None
                richtext.ContextMenuStrip = frmMain.cmsMain
                frmMain.TabControl1.TabPages.Add(edittab)
                frmMain.TabControl1.SelectTab(edittab)
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                    frmMain.TabControl1.SelectedTab.Text = Open.FileName
                    frmMain.openedfile = Open.FileName
                frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                frmMain.TabControl1.SelectedTab.ImageIndex = 5
                frmMain.countwords()
            Catch ex As IndexOutOfRangeException
                Me.Show()
            Catch ex As Exception
                MessageBox.Show("An error occured while opening the file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Me.Show()
                Exit Sub
                ' Do nothing on Exception
            End Try
            Open.Dispose()
            Me.Hide()
            Exit Sub
        End If


        'Replace in current tab
        If comboxEditor.SelectedItem = "Replace current tab with file" And comboxText.SelectedItem = "Plain Text" Then
            If frmMain.lblTabs.Text = 0 Then
                MessageBox.Show("You can't overwrite an non-existant tab. You'll need to create a new one in order to load your file.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If

            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + frmMain.TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNoCancel, "JunkPad II")

                If Response = MsgBoxResult.No Then
                    Dim Open As New OpenFileDialog
                    Dim myStreamReader As System.IO.StreamReader
                    Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                    Open.CheckFileExists = True
                    Open.ShowDialog(Me)
                    Try
                        Open.OpenFile()
                        myStreamReader = System.IO.File.OpenText(Open.FileName)
                        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                        frmMain.TabControl1.SelectedTab.Text = Open.FileName
                        frmMain.openedfile = Open.FileName
                    Catch ex As Exception
                        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
                        frmMain.TabControl1.SelectedTab.ImageIndex = 1
                        Me.Hide()
                        Exit Sub
                    End Try
                    frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                    frmMain.TabControl1.SelectedTab.ImageIndex = 5
                    Open.Dispose()
                    frmMain.countwords()
                    Try
                    Catch ex As IndexOutOfRangeException
                        Me.Show()
                    Catch ex As Exception
                        MessageBox.Show("An error occured while opening the file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Me.Show()
                        Exit Sub
                    End Try
                    Exit Sub
                End If


                If Response = MsgBoxResult.Cancel Then
                    Exit Sub
                End If


                If Response = MsgBoxResult.Yes Then
                    frmSave.comboxEditor.SelectedItem = "Save as plain text file"
                    frmSave.ShowDialog()
                    frmSave.lblFromOpen.Text = 1
                    Dim Open As New OpenFileDialog
                    Dim myStreamReader As System.IO.StreamReader
                    Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                    Open.CheckFileExists = True
                    Open.ShowDialog(Me)
                    Try
                        Open.OpenFile()
                        myStreamReader = System.IO.File.OpenText(Open.FileName)
                        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                            frmMain.TabControl1.SelectedTab.Text = Open.FileName
                            frmMain.openedfile = Open.FileName
                    Catch ex As Exception
                        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
                        frmMain.TabControl1.SelectedTab.ImageIndex = 1
                        Me.Hide()
                        Exit Sub
                    End Try
                    frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                    frmMain.TabControl1.SelectedTab.ImageIndex = 5
                    Open.Dispose()
                    Me.Hide()
                    frmMain.countwords()
                    Try
                    Catch ex As IndexOutOfRangeException
                        Me.Show()
                    Catch ex As Exception
                        MessageBox.Show("An error occured while opening the file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Me.Show()
                        Exit Sub
                    End Try
                    Exit Sub
                End If
            End If


            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False Then
                Dim Open As New OpenFileDialog
                Dim myStreamReader As System.IO.StreamReader
                Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                Open.CheckFileExists = True
                Open.ShowDialog(Me)
                Try
                    Open.OpenFile()
                    myStreamReader = System.IO.File.OpenText(Open.FileName)
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                        frmMain.TabControl1.SelectedTab.Text = Open.FileName
                        frmMain.openedfile = Open.FileName
                        frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                        frmMain.TabControl1.SelectedTab.ImageIndex = 5
                        frmMain.countwords()
                Catch ex As IndexOutOfRangeException
                    Me.Show()
                Catch ex As Exception
                    MessageBox.Show("An error occured while opening the file.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Me.Show()
                    Exit Sub
                End Try
                Open.Dispose()
                Me.Hide()
                Exit Sub
            End If
        End If

        If comboxText.SelectedItem = "Rich Text" And comboxEditor.SelectedItem = "Create new tab & load file" Then
            Dim openFile1 As New OpenFileDialog()
            ' Initialize the OpenFileDialog to look for RTF files.
            openFile1.DefaultExt = "*.dild"
            openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

            ' Determine whether the user selected a file from the OpenFileDialog. 
            If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) And (openFile1.FileName.Length > 0) Then

                ' Load the contents of the file into the RichTextBox.
                Dim richtext As New RichTextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                richtext.BorderStyle = BorderStyle.None
                richtext.ContextMenuStrip = frmMain.cmsMain
                frmMain.TabControl1.TabPages.Add(edittab)
                frmMain.TabControl1.SelectTab(edittab)
                Try
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                    frmMain.TabControl1.SelectedTab.Text = openFile1.FileName
                    frmMain.openedfile = openFile1.FileName
                    frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                    frmMain.TabControl1.SelectedTab.ImageIndex = 5
                    frmMain.countwords()
                Catch ex As ArgumentException
                    MessageBox.Show("This file is missing some information needed to open it in this format.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Catch ex As Exception
                End Try
            End If
            Me.Hide()
            openFile1.Dispose()
            Exit Sub
        End If
        'Replace in current tab
        If comboxEditor.SelectedItem = "Replace current tab with file" And comboxText.SelectedItem = "Rich Text" Then
            Dim openFile1 As New OpenFileDialog()
            If frmMain.lblTabs.Text = 0 Then
                MessageBox.Show("You can't overwrite an non-existant tab. You'll need to create a new one in order to load your file. I'll adjust it for you.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                comboxEditor.SelectedItem = "Create new tab & load file"
                Exit Sub
            End If

            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + frmMain.TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNoCancel, _
                                  "JunkPad II")

                If Response = MsgBoxResult.No Then
                    Try
                        ' Initialize the OpenFileDialog to look for RTF files.
                        openFile1.DefaultExt = "*.dild"
                        openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                        ' Determine whether the user selected a file from the OpenFileDialog. 
                        If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                            And (openFile1.FileName.Length > 0) Then

                            ' Load the contents of the file into the RichTextBox.
                            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                            frmMain.TabControl1.SelectedTab.Text = openFile1.FileName
                            frmMain.openedfile = openFile1.FileName
                            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                            frmMain.TabControl1.SelectedTab.ImageIndex = 5
                            frmMain.countwords()
                        End If
                        Me.Hide()
                        openFile1.Dispose()
                    Catch Ex As Exception
                        MessageBox.Show("Your selected tab isn't Rich Text type!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Me.Show()
                        Exit Sub
                    End Try
                End If

                If Response = MsgBoxResult.Cancel Then
                    Exit Sub
                End If

                If Response = MsgBoxResult.Yes Then
                    frmSave.comboxEditor.SelectedItem = "Save as rich text file"
                    frmSave.ShowDialog()
                    frmSave.lblFromOpen.Text = 1
                    Try
                        ' Initialize the OpenFileDialog to look for RTF files.
                        openFile1.DefaultExt = "*.dild"
                        openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                        ' Determine whether the user selected a file from the OpenFileDialog. 
                        If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                            And (openFile1.FileName.Length > 0) Then

                            ' Load the contents of the file into the RichTextBox.
                            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                            frmMain.TabControl1.SelectedTab.Text = openFile1.FileName
                            frmMain.openedfile = openFile1.FileName
                            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                            frmMain.TabControl1.SelectedTab.ImageIndex = 5
                            frmMain.countwords()
                        End If
                    Catch Ex As Exception
                        MessageBox.Show("Your selected tab isn't Rich Text type!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Me.Show()
                        Exit Sub
                    End Try
                End If
                openFile1.Dispose()
                Me.Hide()
                Exit Sub
            End If
        End If

        If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False Then
            Dim openFile1 As New OpenFileDialog()
            Try
                ' Initialize the OpenFileDialog to look for RTF files.
                openFile1.DefaultExt = "*.dild"
                openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                ' Determine whether the user selected a file from the OpenFileDialog. 
                If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                    And (openFile1.FileName.Length > 0) Then

                    ' Load the contents of the file into the RichTextBox.
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                    frmMain.TabControl1.SelectedTab.Text = openFile1.FileName
                    frmMain.openedfile = openFile1.FileName
                    frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                    frmMain.TabControl1.SelectedTab.ImageIndex = 5
                    frmMain.countwords()
                End If
            Catch Ex As Exception
                MessageBox.Show("Your selected tab isn't Rich Text type!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.Show()
                Exit Sub
            End Try
            openFile1.Dispose()
            Me.Hide()
            Exit Sub
        End If

    End Sub

    Private Sub comboxText_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboxText.SelectedIndexChanged
        If comboxText.SelectedItem = "Rich Text" Then
            lblDetail.Text = "Useful for standard document editing. This type has the ability to change fonts and insert images, but you are limited to either the .DILD or .RTF file type."
        End If
        If comboxText.SelectedItem = "Plain Text" Then
            lblDetail.Text = "Useful for all other types of editing. You cannot change the font or insert images, but this is offset by the ability to open almost any file type that holds text."
        End If
    End Sub

    Private Sub btnAppend_Click(sender As Object, e As EventArgs) Handles btnAppend.Click
        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectAll()
        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Copy()
        If comboxText.SelectedItem = "Rich Text" Then
            Dim openFile1 As New OpenFileDialog()
            ' Initialize the OpenFileDialog to look for RTF files.
            openFile1.DefaultExt = "*.dild"
            openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

            ' Determine whether the user selected a file from the OpenFileDialog. 
            If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                And (openFile1.FileName.Length > 0) Then

                ' Load the contents of the file into the RichTextBox.
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
                frmMain.TabControl1.SelectedTab.ImageIndex = 1
                frmMain.countwords()
                Me.Hide()
            End If
        End If
        'PLAIN TEXT
        If comboxText.SelectedItem = "Plain Text" Then
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectAll()
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Copy()
            Dim Open As New OpenFileDialog
            Dim myStreamReader As System.IO.StreamReader
            Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
            Open.CheckFileExists = True
            Open.ShowDialog(Me)
            Try
                Open.OpenFile()
                myStreamReader = System.IO.File.OpenText(Open.FileName)
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True
                frmMain.TabControl1.SelectedTab.ImageIndex = 1
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                frmMain.countwords()
            Catch ex As Exception
                ' Do nothing on Exception
            End Try
            Open.Dispose()
            lblFromAppend.Text = 0
            comboxEditor.Enabled = True
            btnOpen.Visible = True
            btnAppend.Visible = False
            Me.Hide()
            Exit Sub
        End If
    End Sub

    Private Sub frmOpen_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If lblFromAppend.Text = 1 Then
            comboxEditor.Enabled = False
            btnOpen.Visible = False
            btnAppend.Visible = True
        End If
        If lblFromAppend.Text = 0 Then
            comboxEditor.Enabled = True
            btnOpen.Visible = True
            btnAppend.Visible = False
        End If
    End Sub

    Private Sub comboxEditor_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboxEditor.SelectedIndexChanged
        If frmMain.lblTabs.Text = 0 Then
            MessageBox.Show("No tabs are open. Please select the create a new tab option to continue.")
            comboxEditor.SelectedItem = "Create new tab & load file"
            Exit Sub
        End If
        If comboxEditor.SelectedItem = "Create new tab & load file" Then
            lblEditorSet.Text = "After you select your file, JunkPad will create a new tab and load the file into that. You can change the name of the tab under 'Tab Name Setup'"
        End If
        If comboxEditor.SelectedItem = "Replace current tab with file" Then
            lblEditorSet.Text = "After you select your file, JunkPad will load the file into the selected tab. You can change the name of the tab under 'Tab Name Setup'"
            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                lblEditorSet.Text = "JunkPad will offer you the option to save your modified tab. After you select your file, JunkPad will load the file into the selected tab. You can change the name of the tab under 'Tab Name Setup'"
            End If
        End If
    End Sub

    Private Sub btnBack_Click(sender As Object, e As EventArgs) Handles btnBack.Click
        Me.Hide()
    End Sub
End Class