﻿Public Class frmPrint
    Private checkPrint As Integer
    Private Sub btnBack_Click(sender As Object, e As EventArgs) Handles btnBack.Click
        Me.Close()
    End Sub

    Private Sub frmPrint_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try
            Dim str As String
            str = rtbDoc.TextLength
            lblCharCount.Text = "Characters: " + str
            Try
                Dim i, l, words As Integer
                str = rtbDoc.Text
                str = LTrim(str) 'removes leading blank spaces
                str = RTrim(str) ' removes trailing blank spaces       
                l = str.Length
                i = 0
                words = 0
                While (i < l)
                    If str(i) = " " Then
                        words = words + 1
                        i = i + 1
                        While str(i) = " " ' removes continuous blank spaces
                            i = i + 1
                        End While
                    Else
                        i = i + 1
                    End If

                End While
                words = words + 1 ' adds the last word
                lblWords.Text = ("Words: " & words)
            Catch
            End Try
        Catch ex As Exception
        End Try
    End Sub

    Private Sub btnPageSetup_Click(sender As Object, e As EventArgs) Handles btnPageSetup.Click
        PageSetupDialog1.Document = PrintDocument1
        PageSetupDialog1.ShowDialog()
    End Sub

    Private Sub btnPrintPreview_Click(sender As Object, e As EventArgs) Handles btnPrintPreview.Click
        PrintPreviewDialog1.Document = PrintDocument1
        PrintPreviewDialog1.ShowDialog()
    End Sub

    Private Sub btnPrint_Click(sender As Object, e As EventArgs) Handles btnPrint.Click
        PrintDialog1.Document = PrintDocument1

        If PrintDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            PrintDocument1.Print()
        End If
    End Sub
    Private Sub PrintDocument1_BeginPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs) Handles PrintDocument1.BeginPrint

        ' Adapted from Microsoft's example for extended richtextbox control
        '
        checkPrint = 0

    End Sub


    Private Sub PrintDocument1_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage

        ' Adapted from Microsoft's example for extended richtextbox control
        '
        ' Print the content of the RichTextBox. Store the last character printed.
        checkPrint = rtbDoc.Print(checkPrint, rtbDoc.TextLength, e)

        ' Look for more pages
        If checkPrint < rtbDoc.TextLength Then
            e.HasMorePages = True
        Else
            e.HasMorePages = False
        End If

    End Sub

    Private Sub btnWordWrap_Click(sender As Object, e As EventArgs) Handles btnWordWrap.Click
        If btnWordWrap.Checked = True Then
            rtbDoc.WordWrap = True
        Else
            rtbDoc.WordWrap = False
        End If
    End Sub
End Class