﻿Public Class frmQuickTabs

    Private Sub btnCreateTab_Click(sender As Object, e As EventArgs) Handles btnCreateTab.Click
        If frmMain.lblTabs.Text = 256 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        If frmMain.lblTabs.Text < 256 Then
            If frmMain.lblTabs.Text = 0 Then
                txtBoxName.Enabled = False
            End If
            If frmMain.lblTabs.Text > 0 Then
                txtBoxName.Enabled = True
            End If
            frmMain.addtab()
        End If
    End Sub

    Private Sub btnOK_Click(sender As Object, e As EventArgs) Handles btnOK1.Click
        If frmMain.lblTabs.Text = 0 Then
            Me.Close()
            Exit Sub
        End If
        If frmMain.lblTabs.Text > 0 Then
            frmMain.TabControl1.SelectedTab.Text = txtBoxName.Text
            Me.Close()
        End If
    End Sub

    Private Sub frmQuickTabs_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
    End Sub

    Private Sub frmQuickTabs_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If frmMain.lblTabs.Text = 0 Then
            txtBoxName.Enabled = False
        End If
        If frmMain.lblTabs.Text > 0 Then
            txtBoxName.Enabled = True
            frmMain.TabControl1.SelectedTab.Text = txtBoxName.Text
        End If
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles btnCloneTab.Click
        Dim oldname As String
        oldname = frmMain.TabControl1.SelectedTab.Text
        If frmMain.lblTabs.Text = 0 Then
            MessageBox.Show("You can't duplicate an non-existant tab!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If frmMain.lblTabs.Text = 256 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        Try
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectAll()
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Copy()
            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedText = "" Then
                Dim Response As MsgBoxResult
                Response = MsgBox("Your selected tab has no text in it. Would you like to paste content from the clipboard?", _
                                      MsgBoxStyle.Information + MsgBoxStyle.YesNo, _
                                      "JunkPad II")
                If Response = MsgBoxResult.No Then
                    Dim richtext As New RichTextBox
                    Dim edittab As New TabPage
                    edittab.Controls.Add(richtext)
                    richtext.Dock = DockStyle.Fill
                    richtext.BorderStyle = BorderStyle.None
                    richtext.ContextMenuStrip = frmMain.cmsMain
                    frmMain.TabControl1.TabPages.Add(edittab)
                    frmMain.TabControl1.SelectTab(edittab)
                    frmMain.TabControl1.SelectedTab.Text = oldname
                    frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
                    Me.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    frmMain.TabControl1.SelectedTab.ImageIndex = 4
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                End If

                If Response = MsgBoxResult.Yes Then
                    Dim richtext As New RichTextBox
                    Dim edittab As New TabPage
                    edittab.Controls.Add(richtext)
                    richtext.Dock = DockStyle.Fill
                    richtext.BorderStyle = BorderStyle.None
                    richtext.ContextMenuStrip = frmMain.cmsMain
                    frmMain.TabControl1.TabPages.Add(edittab)
                    frmMain.TabControl1.SelectTab(edittab)
                    frmMain.TabControl1.SelectedTab.Text = oldname
                    frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
                    Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    frmMain.TabControl1.SelectedTab.ImageIndex = 4
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                End If
                Exit Sub
            Else
                Dim richtext As New RichTextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                richtext.BorderStyle = BorderStyle.None
                richtext.ContextMenuStrip = frmMain.cmsMain
                frmMain.TabControl1.TabPages.Add(edittab)
                frmMain.TabControl1.SelectTab(edittab)
                frmMain.TabControl1.SelectedTab.Text = oldname
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Paste()
                frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
                Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                frmMain.TabControl1.SelectedTab.ImageIndex = 4
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
            End If

        Catch ex As Exception
            MessageBox.Show("An error occured while duplicating the tab.", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub radTop_CheckedChanged(sender As Object, e As EventArgs) Handles radTop.CheckedChanged
        If radTop.Checked = True Then
            frmMain.TabControl1.Alignment = TabAlignment.Top
            frmMain.LeftToolStripMenuItem.Enabled = True
            frmMain.RightToolStripMenuItem.Enabled = True
            frmMain.TopdefaultToolStripMenuItem.Enabled = False
            frmMain.BottomToolStripMenuItem.Enabled = True
        End If
    End Sub

    Private Sub radBottom_CheckedChanged(sender As Object, e As EventArgs) Handles radBottom.CheckedChanged
        frmMain.TabControl1.Alignment = TabAlignment.Bottom
        frmMain.LeftToolStripMenuItem.Enabled = True
        frmMain.RightToolStripMenuItem.Enabled = True
        frmMain.TopdefaultToolStripMenuItem.Enabled = True
        frmMain.BottomToolStripMenuItem.Enabled = False
    End Sub

    Private Sub radLeft_CheckedChanged(sender As Object, e As EventArgs) Handles radLeft.CheckedChanged
        frmMain.TabControl1.Alignment = TabAlignment.Left
        frmMain.LeftToolStripMenuItem.Enabled = False
        frmMain.RightToolStripMenuItem.Enabled = True
        frmMain.TopdefaultToolStripMenuItem.Enabled = True
        frmMain.BottomToolStripMenuItem.Enabled = True
    End Sub

    Private Sub radRight_CheckedChanged(sender As Object, e As EventArgs) Handles radRight.CheckedChanged
        frmMain.TabControl1.Alignment = TabAlignment.Right
        frmMain.LeftToolStripMenuItem.Enabled = True
        frmMain.RightToolStripMenuItem.Enabled = False
        frmMain.TopdefaultToolStripMenuItem.Enabled = True
        frmMain.BottomToolStripMenuItem.Enabled = True
    End Sub

    Private Sub chkDisableWordWrap_CheckedChanged(sender As Object, e As EventArgs) Handles chkDisableWordWrap.CheckedChanged
        If chkDisableWordWrap.Checked = False Then
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).WordWrap = True
            frmMain.DisableWordWrapToolStripMenuItem.Checked = True
            Exit Sub
        Else
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).WordWrap = False
            frmMain.DisableWordWrapToolStripMenuItem.Checked = False
            Exit Sub
        End If
    End Sub

    Private Sub chkHideType_CheckedChanged(sender As Object, e As EventArgs) Handles chkHideOnType.CheckedChanged
        If frmMain.lblTabs.Text = 0 Then
            Exit Sub
        End If
        If chkHideOnType.Checked = False Then
            frmMain.ToolStrip1.Hide()
            frmMain.ToolStrip2.Hide()
            frmMain.HidePanelToolStripMenuItem.Enabled = False
            frmMain.ShowPanelToolStripMenuItem.Enabled = True
        Else
            frmMain.ToolStrip1.Show()
            frmMain.ToolStrip2.Show()
            frmMain.HidePanelToolStripMenuItem.Enabled = True
            frmMain.ShowPanelToolStripMenuItem.Enabled = False
        End If
    End Sub

    Private Sub btnClose_Click(sender As Object, e As EventArgs)
        Me.Hide()
    End Sub
End Class