﻿Public Class frmSave

    Private Sub btnBack_Click(sender As Object, e As EventArgs) Handles btnBack.Click
        Me.Hide()
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles btnOpen.Click
        If lblFromSaveChanges.Text = 0 And lblFromOpen.Text = 0 Then
            If comboxEditor.SelectedItem = "Save as plain text file" Then
                Try
                    Dim Save As New SaveFileDialog()
                    Dim myStreamWriter As System.IO.StreamWriter
                    Save.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                    Save.ShowDialog(Me)
                    Save.CheckPathExists = True
                    ' Try
                    myStreamWriter = System.IO.File.CreateText(Save.FileName)
                    myStreamWriter.Write(Replace(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text, Chr(10), Environment.NewLine))
                    myStreamWriter.Flush()
                    frmMain.TabControl1.SelectedTab.Text = Save.FileName
                    frmMain.openedfile = ""
                    frmMain.openedfile = Save.FileName
                    Save.Dispose()
                    frmMain.Text = "JunkPad II - " + Save.FileName
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                    frmMain.TabControl1.SelectedTab.ImageIndex = 3
                    Me.Hide()
                Catch ex As System.ArgumentException
                    'This error occurs every time the save file dialog is closed with the cancel button. We're going to ignore it.
                Catch ex As System.IO.IOException
                    MessageBox.Show("An error occured while saving the file: Maybe another program is using the file, or the drive it was located on was removed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Catch ex As Exception 'catch all other exceptions
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
                Exit Sub
            End If

            If comboxEditor.SelectedItem = "Save as rich text file" Then
                Dim saveFile1 As New SaveFileDialog()
                ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                saveFile1.DefaultExt = "*.dild"
                saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                ' Determine whether the user selected a file name from the saveFileDialog. 
                If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                    And (saveFile1.FileName.Length > 0) Then

                    ' Save the contents of the RichTextBox into the file.
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                    frmMain.TabControl1.SelectedTab.Text = saveFile1.FileName
                    frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                    frmMain.TabControl1.SelectedTab.ImageIndex = 3
                    frmMain.openedfile = saveFile1.FileName
                    saveFile1.Dispose()
                    Me.Hide()
                End If
                Exit Sub
            End If
            Exit Sub
        End If
        ' if it's called from the save changes menu
        If lblFromSaveChanges.Text = 1 Then
            If comboxEditor.SelectedItem = "Save as plain text file" Then
                Dim Save As New SaveFileDialog()
                Dim myStreamWriter As System.IO.StreamWriter
                Save.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                Save.ShowDialog(Me)
                Save.CheckPathExists = True
                Try
                    myStreamWriter = System.IO.File.CreateText(Save.FileName)
                    myStreamWriter.Write(Replace(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text, Chr(10), Environment.NewLine), RichTextBoxStreamType.PlainText)
                    myStreamWriter.Flush()
                    frmMain.TabControl1.SelectedTab.Text = Save.FileName
                    frmMain.openedfile = ""
                    frmMain.openedfile = Save.FileName
                    Save.Dispose()
                    frmMain.Text = "JunkPad II - " + Save.FileName
                    frmMain.TabControl1.TabPages.Remove(frmMain.TabControl1.SelectedTab)
                    frmMain.lblTabs.Text = frmMain.lblTabs.Text - 1
                    lblFromSaveChanges.Text = 0
                    Me.Hide()
                Catch ex As System.ArgumentException
                    'This error occurs every time the save file dialog is closed. We're going to ignore it.
                Catch ex As System.IO.IOException
                    MessageBox.Show("An error occured while saving the file: Maybe another program is using the file, or the drive it was located on was removed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Catch ex As Exception 'catch all other exceptions
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
            If comboxEditor.SelectedItem = "Save as rich text file" Then
                Dim saveFile1 As New SaveFileDialog()
                ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                saveFile1.DefaultExt = "*.dild"
                saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                ' Determine whether the user selected a file name from the saveFileDialog. 
                If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                    And (saveFile1.FileName.Length > 0) Then

                    ' Save the contents of the RichTextBox into the file.
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                    frmMain.TabControl1.SelectedTab.Text = saveFile1.FileName
                    saveFile1.Dispose()
                    frmMain.TabControl1.TabPages.Remove(frmMain.TabControl1.SelectedTab)
                    frmMain.lblTabs.Text = frmMain.lblTabs.Text - 1
                    lblFromSaveChanges.Text = 0
                    Me.Hide()
                End If
                Exit Sub
            End If
        End If
        'if it's called from the Open File dialog
        If lblFromOpen.Text = 1 Then
            If comboxEditor.SelectedItem = "Save as plain text file" Then
                Dim Save As New SaveFileDialog()
                Dim myStreamWriter As System.IO.StreamWriter
                Save.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                Save.ShowDialog(Me)
                Save.CheckPathExists = True
                Try
                    myStreamWriter = System.IO.File.CreateText(Save.FileName)
                    myStreamWriter.Write(Replace(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text, Chr(10), Environment.NewLine), RichTextBoxStreamType.PlainText)
                    myStreamWriter.Flush()
                    lblFromOpen.Text = 0
                    Me.Hide()
                    Save.Dispose()
                    MessageBox.Show("Saved file successfully!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Catch ex As System.ArgumentException
                    'This error occurs every time the save file dialog is closed. We're going to ignore it.
                Catch ex As System.IO.IOException
                    MessageBox.Show("An error occured while saving the file: Maybe another program is using the file, or the drive it was located on was removed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Catch ex As Exception 'catch all other exceptions
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If

            If comboxEditor.SelectedItem = "Save as rich text file" Then
                Dim saveFile1 As New SaveFileDialog()
                ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                saveFile1.DefaultExt = "*.dild"
                saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                ' Determine whether the user selected a file name from the saveFileDialog. 
                If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                    And (saveFile1.FileName.Length > 0) Then

                    ' Save the contents of the RichTextBox into the file.
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                    lblFromOpen.Text = 0
                    Me.Hide()
                    saveFile1.Dispose()
                End If
            End If
            ' if it's called when the program closes.
            If lblFromSaveBtn.Text = 1 Then
                If comboxEditor.SelectedItem = "Save as plain text file" Then
                    Dim Save As New SaveFileDialog()
                    Dim myStreamWriter As System.IO.StreamWriter
                    Save.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                    Save.ShowDialog(Me)
                    Save.CheckPathExists = True
                    Try
                        myStreamWriter = System.IO.File.CreateText(Save.FileName)
                        myStreamWriter.Write(Replace(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text, Chr(10), Environment.NewLine), RichTextBoxStreamType.PlainText)
                        myStreamWriter.Flush()
                        lblFromOpen.Text = 0
                    Catch ex As System.ArgumentException
                        'This error occurs every time the save file dialog is closed. We're going to ignore it.
                    Catch ex As System.IO.IOException
                        MessageBox.Show("An error occured while saving the file: Maybe another program is using the file, or the drive it was located on was removed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Catch ex As Exception 'catch all other exceptions
                        MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End Try
                    End
                    Save.Dispose()
                End If
                If comboxEditor.SelectedItem = "Save as rich text file" Then
                    Dim saveFile1 As New SaveFileDialog()
                    ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                    saveFile1.DefaultExt = "*.dild"
                    saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                    ' Determine whether the user selected a file name from the saveFileDialog. 
                    If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (saveFile1.FileName.Length > 0) Then
                        ' Save the contents of the RichTextBox into the file.
                        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                        saveFile1.Dispose()
                        End
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub comboxEditor_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboxEditor.SelectedIndexChanged
        If comboxEditor.SelectedItem = "Save as plain text file" Then
            lblEditorSet.Text = "This does not preserve any of the formatting, colouring and images in the document, but this is what can be called the final save, meaning it's like you saved it with the plain text tab type."
        End If
        If comboxEditor.SelectedItem = "Save as rich text file" Then
            lblEditorSet.Text = "Saving this file in this way will preserve the formatting, colouring and images in the document, but it can only be opened with either the Rich Text tab type or the Code tab type."
        End If
    End Sub

    Private Sub frmSave_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If lblFromSave1.Text = 1 Then
            If comboxEditor.SelectedItem = "Save as rich text file" Then
                ' Save the contents of the RichTextBox into the file.
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(frmMain.openedfile)
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                frmMain.TabControl1.SelectedTab.ImageIndex = 3
                Me.Hide()
            End If
            If comboxEditor.SelectedItem = "Save as plain text file" Then
                Try
                    Dim txtWriter As System.IO.StreamWriter
                    txtWriter = New System.IO.StreamWriter(frmMain.openedfile)
                    txtWriter.Write(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text)
                    txtWriter.Close()
                    txtWriter = Nothing
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
                Catch ex As System.ArgumentException
                    'This error occurs every time the save file dialog is closed. We're going to ignore it.
                Catch ex As System.IO.IOException
                    MessageBox.Show("An error occured while saving the file: Maybe another program is using the file, or the drive it was located on was removed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Catch ex As System.UnauthorizedAccessException
                    MessageBox.Show("Can't save here! Access is denied.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Catch ex As Exception 'catch all other exceptions
                    MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
            End If
            lblFromSave1.Text = 0
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False
            frmMain.TabControl1.SelectedTab.ImageIndex = 3
                If lblFromSaveBtn.Text = 1 Then
                    End
                End If
                Me.Close()
        End If
    End Sub
End Class