﻿Public Class frmOpen

    Private Sub btnBack_Click(sender As Object, e As EventArgs) Handles btnBack.Click
        Me.Hide()
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles btnOpen.Click
        Dim Response As MsgBoxResult
        If comboxEditor.SelectedItem = "Create new tab & load file" And comboxText.SelectedItem = "Rich Text" Then
            Dim openFile1 As New OpenFileDialog()
            ' Initialize the OpenFileDialog to look for RTF files.
            openFile1.DefaultExt = "*.dild"
            openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

            ' Determine whether the user selected a file from the OpenFileDialog. 
            If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                And (openFile1.FileName.Length > 0) Then

                ' Load the contents of the file into the RichTextBox.
                Dim richtext As New RichTextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                frmMain.TabControl1.TabPages.Add(edittab)
                frmMain.TabControl1.SelectTab(edittab)
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)

                If txtboxTabName.Text = "unnamed" Then
                    frmMain.TabControl1.SelectedTab.Text = openFile1.SafeFileName
                Else
                    frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
                End If
                frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
            End If
                Me.Hide()
                Exit Sub
        End If
        'Replace in current tab
        If comboxEditor.SelectedItem = "Replace current tab with file" And comboxText.SelectedItem = "Rich Text" Then
            If frmMain.lblTabs.Text = 0 Then
                MessageBox.Show("You can't overwrite an non-existant tab. Try the other option.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If
            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + frmMain.TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad")
                If Response = MsgBoxResult.No Then
                    Dim openFile1 As New OpenFileDialog()
                    Try
                        ' Initialize the OpenFileDialog to look for RTF files.
                        openFile1.DefaultExt = "*.dild"
                        openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                        ' Determine whether the user selected a file from the OpenFileDialog. 
                        If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                            And (openFile1.FileName.Length > 0) Then

                            ' Load the contents of the file into the RichTextBox.
                            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                            If txtboxTabName.Text = "unnamed" Then
                                frmMain.TabControl1.SelectedTab.Text = openFile1.SafeFileName
                            Else
                                frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
                            End If
                            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                        End If
                        Me.Hide()
                    Catch Ex As Exception
                        MessageBox.Show("Your selected tab isn't Rich Text type!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Me.Show()
                        Exit Sub
                    End Try
                    If Response = MsgBoxResult.Yes Then
                        Dim saveFile1 As New SaveFileDialog()

                        ' Initialize the SaveFileDialog to specify the RTF extention for the file.
                        saveFile1.DefaultExt = "*.dild"
                        saveFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf|All files (*.*)|*.*"

                        ' Determine whether the user selected a file name from the saveFileDialog. 
                        If (saveFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                            And (saveFile1.FileName.Length > 0) Then

                            ' Save the contents of the RichTextBox into the file.
                            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SaveFile(saveFile1.FileName)
                            frmMain.TabControl1.SelectedTab.Text = saveFile1.FileName
                            Try
                                ' Initialize the OpenFileDialog to look for RTF files.
                                openFile1.DefaultExt = "*.dild"
                                openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                                ' Determine whether the user selected a file from the OpenFileDialog. 
                                If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                                    And (openFile1.FileName.Length > 0) Then

                                    ' Load the contents of the file into the RichTextBox.
                                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                                    If txtboxTabName.Text = "unnamed" Then
                                        frmMain.TabControl1.SelectedTab.Text = openFile1.SafeFileName
                                    Else
                                        frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
                                    End If
                                    frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                                End If
                            Catch Ex As Exception
                                MessageBox.Show("Your selected tab isn't Rich Text type!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                                Me.Show()
                                Exit Sub
                            End Try
                        End If
                        Me.Hide()
                        Exit Sub
                    End If
                End If
            End If
            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False Then
                Dim openFile1 As New OpenFileDialog()
                Try
                    ' Initialize the OpenFileDialog to look for RTF files.
                    openFile1.DefaultExt = "*.dild"
                    openFile1.Filter = "DILD Files (*.dild)|*.dild|Rich Text Files (*.rtf)|*.rtf"

                    ' Determine whether the user selected a file from the OpenFileDialog. 
                    If (openFile1.ShowDialog() = System.Windows.Forms.DialogResult.OK) _
                        And (openFile1.FileName.Length > 0) Then

                        ' Load the contents of the file into the RichTextBox.
                        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).LoadFile(openFile1.FileName)
                        If txtboxTabName.Text = "unnamed" Then
                            frmMain.TabControl1.SelectedTab.Text = openFile1.SafeFileName
                        Else
                            frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
                        End If
                        frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    End If
                Catch Ex As Exception
                    MessageBox.Show("Your selected tab isn't Rich Text type!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Me.Show()
                    Exit Sub
                End Try
                Me.Hide()
                Exit Sub
            End If
        End If
        'Plain Text open from hereon
        If comboxEditor.SelectedItem = "Create new tab & load file" And comboxText.SelectedItem = "Plain Text" Then
            Dim Open As New OpenFileDialog
            Dim myStreamReader As System.IO.StreamReader
            Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
            Open.CheckFileExists = True
            Open.ShowDialog(Me)
            Try
                Open.OpenFile()
                myStreamReader = System.IO.File.OpenText(Open.FileName)
                Dim richtext As New RichTextBox
                Dim edittab As New TabPage
                edittab.Controls.Add(richtext)
                richtext.Dock = DockStyle.Fill
                richtext.Multiline = True
                frmMain.TabControl1.TabPages.Add(edittab)
                frmMain.TabControl1.SelectTab(edittab)
                CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                If txtboxTabName.Text = "unnamed" Then
                    frmMain.TabControl1.SelectedTab.Text = Open.SafeFileName
                Else
                    frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
                End If
                frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
            Catch ex As Exception
                ' Do nothing on Exception
            End Try
            Me.Hide()
            Exit Sub
        End If
            'Replace in current tab
        If comboxEditor.SelectedItem = "Replace current tab with file" And comboxText.SelectedItem = "Plain Text" Then
            If frmMain.lblTabs.Text = 0 Then
                MessageBox.Show("You can't overwrite an non-existant tab. Try the other option.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If
            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = True Then
                Response = MsgBox("Save changes to " + frmMain.TabControl1.SelectedTab.Text + " ?", _
                                  MsgBoxStyle.Exclamation + MsgBoxStyle.YesNo, _
                                  "JunkPad")
                If Response = MsgBoxResult.No Then
                    Dim Open As New OpenFileDialog
                    Dim myStreamReader As System.IO.StreamReader
                    Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                    Open.CheckFileExists = True
                    Open.ShowDialog(Me)

                    Open.OpenFile()
                    myStreamReader = System.IO.File.OpenText(Open.FileName)
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                    If txtboxTabName.Text = "unnamed" Then
                        frmMain.TabControl1.SelectedTab.Text = Open.SafeFileName
                    Else
                        frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
                    End If
                    frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                    Try
                    Catch ex As Exception
                        MessageBox.Show("Your selected tab isn't Plain Text type!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Me.Show()
                        Exit Sub
                    End Try
                    Exit Sub
                End If
                If Response = MsgBoxResult.Yes Then
                    Dim Save As New SaveFileDialog()
                    Dim myStreamWriter As System.IO.StreamWriter
                    Save.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                    Save.CheckPathExists = True
                    Save.ShowDialog(Me)
                    Try
                        myStreamWriter = System.IO.File.CreateText(Save.FileName)
                        myStreamWriter.Write(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text)
                        myStreamWriter.Flush()
                        frmMain.TabControl1.SelectedTab.Text = Save.FileName
                    Catch ex As System.ArgumentException
                        'This error occurs every time the save file dialog is closed. We're going to ignore it.
                    Catch ex As System.IO.IOException
                        MessageBox.Show("An error occured while saving the file: Maybe another program is using the file, or the drive it was located on was removed.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Catch ex As Exception 'catch all other exceptions
                        MessageBox.Show("Saving failed!", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End Try
                    Me.Hide()
                    Exit Sub
                End If
            End If
            If CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Modified = False Then
                Dim Open As New OpenFileDialog
                Dim myStreamReader As System.IO.StreamReader
                Open.Filter = "Text Files (*.txt)|*.txt|Batch Files (*.bat)|*.bat|HTML Files (*.html; *.htm)|*.html; *.htm|PHP Files (*.php)|*.php|INF Files (*.inf)|*.inf|INI Files (*.ini)|*.ini|CFG Files (*.cfg)|*.cfg|COM Files (*.com)|*.com|Visual Basic source files (*.vb)|*.vb|CSharp source files (*.cs)|*.cs|Visual Studio Solution files (*.sln)|*.sln|All files (*.*)|*.*"
                Open.CheckFileExists = True
                Open.ShowDialog(Me)
                Try
                    Open.OpenFile()
                    myStreamReader = System.IO.File.OpenText(Open.FileName)
                    CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text = myStreamReader.ReadToEnd()
                    If txtboxTabName.Text = "unnamed" Then
                        frmMain.TabControl1.SelectedTab.Text = Open.SafeFileName
                    Else
                        frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
                    End If
                    frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
                Catch ex As Exception
                    MessageBox.Show("Your selected tab isn't Plain Text type!", "JunkPad", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Me.Show()
                    Exit Sub
                End Try
                Me.Hide()
            End If
        End If
    End Sub

    Private Sub comboxText_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboxText.SelectedIndexChanged
        If comboxText.SelectedItem = "Rich Text" Then
            lblDetail.Text = "Useful for standard document editing. This type has the ability to change fonts and insert images, but you are limited to either the .DILD or .RTF file type."
        End If
        If comboxText.SelectedItem = "Plain Text" Then
            lblDetail.Text = "Useful for all other types of editing. You cannot change the font or insert images, but this is offset by the ability to open almost any file type that holds text."
        End If
    End Sub

    Private Sub comboxEditor_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboxEditor.SelectedIndexChanged
        If comboxEditor.SelectedItem = "Create new tab & load file" Then
            lblEditorSet.Text = "After you select your file, JunkPad will create a new tab and load the file into that. You can change the name of the tab under 'Tab Name Setup'"
        End If
        If comboxEditor.SelectedItem = "Replace current tab with file" Then
            lblEditorSet.Text = "After you select your file, JunkPad will overwrite the content in your selected tab. If you've modified the tab, a message will appear asking you to save changes. You can change the name of the tab under 'Tab Name Setup'"
        End If
    End Sub

    Private Sub frmOpen_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If frmMain.lblTabType.Text = "Plain Text" Then
            comboxText.SelectedItem = "Plain Text"
        End If
        If frmMain.lblTabType.Text = "Rich Text" Then
            comboxText.SelectedItem = "Rich Text"
        End If
    End Sub
End Class