﻿Public Class frmSearch

    Private Sub findnext()
        Dim StartPosition As Integer
        If radDown.Checked = True Then
            StartPosition = CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionStart + 2 'moves the selected text down the page
        Else
            StartPosition = CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionStart - 2 / 1 'moves the selected text back up the page
        End If
        Dim SearchType As CompareMethod
        If chkMatchCase.Checked = True Then
            SearchType = CompareMethod.Binary
        Else
            SearchType = CompareMethod.Text
        End If
        Find()
        Try
            StartPosition = InStr(StartPosition, CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text,
        txtFind.Text, SearchType)
            If StartPosition = 0 Then
                MessageBox.Show("Text: " & txtFind.Text.ToString() & " wasn't found.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
                Exit Sub
            End If
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Select(StartPosition - 1, txtFind.Text.Length)
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).ScrollToCaret()
            frmMain.Focus()
        Catch ex As Exception
            Me.Focus()
            MessageBox.Show("Text: " & txtFind.Text.ToString() & " wasn't found. Reason: Hit beginning of document", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
        End Try
    End Sub

    Private Sub findnext1()
        Dim StartPosition As Integer
        If radDown.Checked = True Then
            StartPosition = CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionStart + 2 'moves the selected text down the page
        Else
            StartPosition = CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionStart - 2 + 1 'moves the selected text back up the page
        End If
        Dim SearchType As CompareMethod
        If chkMatchCase1.Checked = True Then
            SearchType = CompareMethod.Binary
        Else
            SearchType = CompareMethod.Text
        End If
        Try
            StartPosition = InStr(StartPosition, CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text,
        txtFind1.Text, SearchType)
            If StartPosition = 0 Then
                MessageBox.Show("Text: " & txtFind1.Text.ToString() & " wasn't found.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
                Exit Sub
            End If
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Select(StartPosition - 1, txtFind.Text.Length)
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).ScrollToCaret()
            frmMain.Focus()
        Catch ex As Exception
            MessageBox.Show("Text: " & txtFind1.Text.ToString() & " wasn't found.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
        End Try
    End Sub

    Private Sub Find()
        Dim StartPosition As Integer
        Dim SearchType As CompareMethod

        If chkMatchCase.Checked = True Then
            SearchType = CompareMethod.Binary
        Else
            SearchType = CompareMethod.Text
        End If

        StartPosition = InStr(1, CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text, txtFind.Text, SearchType)

        If StartPosition = 0 Then
            MessageBox.Show("Text: " & txtFind.Text.ToString() & " wasn't found.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
            Exit Sub
        End If

        If radDown.Checked = True Then
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Select(StartPosition - 1, txtFind.Text.Length)
        Else
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Select(StartPosition + 1, txtFind.Text.Length)
        End If
        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).ScrollToCaret()
        frmMain.Focus()
    End Sub

    Private Sub Find1()
        Dim StartPosition As Integer
        Dim SearchType As CompareMethod

        If chkMatchCase1.Checked = True Then
            SearchType = CompareMethod.Binary
        Else
            SearchType = CompareMethod.Text
        End If

        StartPosition = InStr(1, CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text, txtFind1.Text, SearchType)

        If StartPosition = 0 Then
            MessageBox.Show("Text: " & txtFind1.Text.ToString() & " wasn't found.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
            Exit Sub
        End If

        If radDown.Checked = True Then
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Select(StartPosition - 1, txtFind1.Text.Length)
        Else
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Select(StartPosition + 1, txtFind1.Text.Length)
        End If
        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).ScrollToCaret()
        frmMain.Focus()
    End Sub

    Private Sub btnReplace_Click(sender As Object, e As EventArgs) Handles btnReplace.Click
        Dim a As String
        Dim b As String
        Dim c As String
        a = txtFind1.Text
        b = InStr(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text, a)
        c = txtReplace.Text
        If a = String.Empty Then Exit Sub
        If b Then
            frmMain.Focus()
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionStart = b - 1
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionLength = Len(a)
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedText = c
            Me.Focus()
            MessageBox.Show(a + " was replaced with " + c, "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            MessageBox.Show(a + " wasn't found in this tab.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub ReplaceAll()
        Dim text As String = CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text
        Dim find As String = txtFind1.Text
        Dim result As Integer = CInt((text.Length - text.Replace(find, "").Length) / find.Length)
        Dim currentPosition As Integer
        Dim currentSelect As Integer
        If chkSelection.Checked = True Then
            CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedRtf = Replace(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectedRtf, Trim(txtFind1.Text), Trim(txtReplace.Text))
            Exit Sub
        Else
            currentPosition = CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionStart()
            currentSelect = CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionLength
        End If
        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Rtf = Replace(CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Rtf, Trim(txtFind1.Text), Trim(txtReplace.Text))
        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionStart = currentPosition
        CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).SelectionLength = currentSelect
        If result = 0 Then
            MessageBox.Show("Replaced 0 of string '" + txtFind1.Text + "' with '" + txtReplace.Text + "'", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        Else
            MessageBox.Show("Replaced " & result & " of string '" + txtFind1.Text + "' with '" + txtReplace.Text + "'", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
        frmMain.Focus()
    End Sub

    Private Sub btnClose_Click_1(sender As Object, e As EventArgs) Handles btnClose.Click
        Me.Hide()
    End Sub

    Private Sub btnFindNext_Click_1(sender As Object, e As EventArgs) Handles btnFindNext.Click
        findnext()
    End Sub

    Private Sub btnFind_Click(sender As Object, e As EventArgs) Handles btnFind.Click
        Find()
    End Sub

    Private Sub trkTransparency_Scroll(sender As Object, e As EventArgs) Handles trkTransparency.Scroll
        If radAlways.Checked = True And chkTransparency.Checked = True Then
            Form.ActiveForm.Opacity = trkTransparency.Value / trkTransparency.Maximum
        End If
    End Sub

    Private Sub frmSearch_GotFocus(sender As Object, e As EventArgs) Handles Me.Activated
        If radLostFocus.Checked = True And chkTransparency.Checked = True Then
            Me.Opacity = 1
        End If
    End Sub

    Private Sub chkTransparency_CheckedChanged(sender As Object, e As EventArgs) Handles chkTransparency.CheckedChanged
        If chkTransparency.Checked = False Then
            Me.Opacity = 1
        End If
    End Sub

    Private Sub frmSearch_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Height = 213
        Me.Focus()
        Form.ActiveForm.Opacity = 1
    End Sub

    Private Sub frmSearch_Leave(sender As Object, e As EventArgs) Handles Me.Deactivate
        If radLostFocus.Checked = True And chkTransparency.Checked = True Then
            Me.Opacity = 0.5
        End If
    End Sub

    Private Sub btnReplaceAll_Click_1(sender As Object, e As EventArgs) Handles btnReplaceAll.Click
        ReplaceAll()
    End Sub

    Private Sub btnFind1_Click(sender As Object, e As EventArgs) Handles btnFind1.Click
        Find1()
    End Sub

    Private Sub btnFindNext1_Click(sender As Object, e As EventArgs) Handles btnFindNext1.Click
        findnext1()
    End Sub

    Private Sub btnSwap_Click(sender As Object, e As EventArgs) Handles btnSwap.Click
        Dim uppertext As String = txtFind1.Text
        Dim lowertext As String = txtReplace.Text
        txtReplace.Text = uppertext
        txtFind1.Text = lowertext
        'now we'll flip them around
        uppertext = txtFind1.Text
        lowertext = txtReplace.Text
    End Sub

    Private Sub btnDown_Click(sender As Object, e As EventArgs) Handles btnDown.Click
        Me.Height = 298
        pnlOptions.Show()
        btnDown.Hide()
        btnDown1.Hide()
        btnUp.Show()
        btnUp1.Show()
    End Sub

    Private Sub btnUp_Click(sender As Object, e As EventArgs) Handles btnUp.Click
        Me.Height = 213
        pnlOptions.Hide()
        btnDown.Show()
        btnDown1.Show()
        btnUp.Hide()
        btnUp1.Hide()
    End Sub

    Private Sub btnCount_Click(sender As Object, e As EventArgs) Handles btnCount.Click
        Try
            Dim text As String = CType(frmMain.TabControl1.SelectedTab.Controls.Item(0), RichTextBox).Text
            Dim find As String = txtFind.Text
            Dim result As Integer = CInt((text.Length - text.Replace(find, "").Length) / find.Length)
            If result = 0 Then
                MessageBox.Show("Found: 0 of string '" + txtFind.Text + "'", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            Else
                MessageBox.Show("Found: " & result & " of string '" + txtFind.Text + "'", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        Catch ex As ArgumentException
            MessageBox.Show("Please enter a string in the find box to count occurances.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub

    Private Sub btnDown1_Click(sender As Object, e As EventArgs) Handles btnDown1.Click
        Me.Height = 298
        pnlOptions.Show()
        btnDown.Hide()
        btnDown1.Hide()
        btnUp.Show()
        btnUp1.Show()
    End Sub

    Private Sub btnUp1_Click(sender As Object, e As EventArgs) Handles btnUp1.Click
        Me.Height = 213
        pnlOptions.Hide()
        btnDown.Show()
        btnDown1.Show()
        btnUp.Hide()
        btnUp1.Hide()
    End Sub
End Class