﻿Public Class frmNewTab

    Private Sub btnCreateTab_Click(sender As Object, e As EventArgs) Handles btnCreateTab.Click
        If frmMain.lblTabs.Text = "384" Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        If comboxText.SelectedItem = "Rich Text" Then
            frmMain.btnImage.Enabled = True
            frmMain.btnImage.ToolTipText = "Insert an image into your document"
            frmMain.btnColour.Enabled = True
            frmMain.btnColour.ToolTipText = "Change the Font Colour"
            frmMain.btnFont.Enabled = True
            frmMain.btnFont.ToolTipText = "Change the font face, size and format."
            Dim richtext As New RichTextBox
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            frmMain.TabControl1.TabPages.Add(edittab)
            frmMain.TabControl1.SelectTab(edittab)
            frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
            frmMain.lblTabType.Text = "Rich Text"
            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
            frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
            Exit Sub
        End If
        If comboxText.SelectedItem = "Plain Text" Then
            frmMain.btnImage.Enabled = False
            frmMain.btnImage.ToolTipText = "Images can't be inserted into plain text fields, because they can't be saved in this type."
            frmMain.btnColour.Enabled = False
            frmMain.btnColour.ToolTipText = "Font colour is not supported by this type."
            frmMain.btnFont.Enabled = False
            frmMain.btnFont.ToolTipText = "Changing the font format is not supported by this type."
            Dim richtext As New TextBox
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            richtext.Multiline = True
            frmMain.TabControl1.TabPages.Add(edittab)
            frmMain.TabControl1.SelectTab(edittab)
            frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
            frmMain.lblTabType.Text = "Plain Text"
            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
            frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
            Exit Sub
        End If
    End Sub

    Private Sub btnOK_Click(sender As Object, e As EventArgs) Handles btnOK.Click
        Me.Hide()
    End Sub

    Private Sub comboxText_SelectedIndexChanged_1(sender As Object, e As EventArgs) Handles comboxText.SelectedIndexChanged
        If comboxText.SelectedItem = "Rich Text" Then
            lblDetail.Text = "Useful for standard document editing. This type has the ability to change fonts and insert images. You are limited to either the .DILD or .RTF file type."
        End If
        If comboxText.SelectedItem = "Plain Text" Then
            lblDetail.Text = "Useful for all other types of editing. You cannot change the font or insert images, but this is offset by the ability to open almost any file type."
        End If
    End Sub

    Private Sub btnBack_Click(sender As Object, e As EventArgs) Handles btnBack.Click
        Me.Hide()
    End Sub
End Class