﻿Public Class frmQuickTabs

    Private Sub btnOK_Click(sender As Object, e As EventArgs) Handles btnOK.Click
        frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
        Me.Hide()
    End Sub

    Private Sub btnCreateTab_Click(sender As Object, e As EventArgs) Handles btnCreateTab.Click
        If frmMain.lblTabs.Text = 384 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        If comboxText.SelectedItem = "Rich Text" Then
            Dim richtext As New RichTextBox
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            frmMain.TabControl1.TabPages.Add(edittab)
            frmMain.TabControl1.SelectTab(edittab)
            frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
            frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
            Exit Sub
        End If
        If comboxText.SelectedItem = "Plain Text" Then
            Dim richtext As New TextBox
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            richtext.Multiline = True
            frmMain.TabControl1.TabPages.Add(edittab)
            frmMain.TabControl1.SelectTab(edittab)
            frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
            frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
        End If
    End Sub

    Private Sub comboxText_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboxText.SelectedIndexChanged
        If comboxText.SelectedItem = "Rich Text" Then
            lblDetail.Text = "Useful for standard document editing. This type has the ability to change fonts and insert images. You are limited to either the .DILD or .RTF file type."
        End If
        If comboxText.SelectedItem = "Plain Text" Then
            lblDetail.Text = "Useful for all other types of editing. You cannot change the font or insert images, but this is offset by the ability to open almost any file type."
        End If
    End Sub

    Private Sub btnOK1_Click(sender As Object, e As EventArgs) Handles btnOK1.Click
        If frmMain.lblTabs.Text = 384 Then
            MessageBox.Show("You have reached the maximux allowed tabs that can be created.", "JunkPad II", MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Exit Sub
        End If
        If comboxText.SelectedItem = "Rich Text" Then
            Dim richtext As New RichTextBox
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            frmMain.TabControl1.TabPages.Add(edittab)
            frmMain.TabControl1.SelectTab(edittab)
            frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
            frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
            Me.Hide()
            Exit Sub
        End If
        If comboxText.SelectedItem = "Plain Text" Then
            Dim richtext As New TextBox
            Dim edittab As New TabPage
            edittab.Controls.Add(richtext)
            richtext.Dock = DockStyle.Fill
            richtext.Multiline = True
            frmMain.TabControl1.TabPages.Add(edittab)
            frmMain.TabControl1.SelectTab(edittab)
            frmMain.TabControl1.SelectedTab.Text = txtboxTabName.Text
            frmMain.Text = "JunkPad II - " + frmMain.TabControl1.SelectedTab.Text
            frmMain.lblTabs.Text = frmMain.lblTabs.Text + 1
            Me.Hide()
        End If
    End Sub
End Class